<html>
<head>
	<title>Directed Kicker Bots</title>
	<link rel="stylesheet" type="text/css" href="../styles.css"/>
</head>
<body>
<div id="content">
	<h2>Directed Kicker Bots</h2>
	<h3>Agent Algorithm</h3>
	<p>
		A directed kicker agent chooses a visible ball at random and
		tries to "kick" it so that the ball will move in the the agent's
		goal direction. The agent calculates the spot on the ball it
		needs to hit to knock the ball in the right direction. If it
		senses that moving directly towards the target spot will
		result in kicking the ball in another direction, the agent
		accelerates around the agent (orthagonal to the vector towards the
		target spot) until it can hit the target spot.
	</p>
	<h4>Pseudocode</h4>
	<div class="pseudocode">
<pre>visibleBalls = {}
for all visibleObjects
   if visibleObject is ball
      visibleBalls <-- visibleObject
if visibleBalls is not empty
   ball = selectRandom(visibleBalls)
   targetVector = vectorToBallCenter - (ball.radius + agent.radius) * goalDirection
   if dotProduct(targetVector, vectorToBallCenter) > 0
      acceleration = targetVector
   else
      orthagonalToTarget = rotate(targetVector, 90&deg;)
      if dotProduct(orthagonalToTarget, goalDirection) > 0
         orthagonalToTarget = -1 * orthagonalToTarget
      acceleration = orthagonalToTarget
else
   set acceleration to zero</pre>
	</div>
	<h3>Observed Behavior</h3>
	<p>
		The agents definitely do organize themselves on the correct
		sides of the ball, and depending on how many agents of which color
		are concentrating on a ball, the ball is moved in the goal
		direction of the team with the majority focused on that ball.
	</p>
	<p>
		It seems, however, that the agents do a lot more "positioning
		to kick" than actual kicking. They all line up on their
		side of the ball and follow the ball around. This could be good
		for defense in a soccer-style game, but not aggressive enough for
		offense.
	</p>
	<h3>The Applet</h3>
	<applet archive="../dist/appletbots.jar"
	        code="appletbots.directedballs.DirectedBallsApplet"
	        alt="Directed Balls Applet"
	        width="600"
	        height="520">
		<div>
			If you see this, you need to either enable java, or install the Sun Java
			Virtual Machine in your browser. To do so,
			<a href="http://java.sun.com/getjava/download.html">click here</a>.
		</div>
	</applet>
	<h3>Source Code</h3>
	<ul>
		<li>
			<a href="http://repo.or.cz/w/applet-bots.git?a=blob;f=src/appletbots/directedballs/DirectedBallsApplet.java">DirectedBallsApplet.java</a>
		</li>
		<li>
			<a href="http://repo.or.cz/w/applet-bots.git?a=blob;f=src/appletbots/directedballs/DirectedKicker.java">DirectedKicker.java</a>
		</li>
	</ul>
	<a href="../" class="return">Back to the Applet Bots Home</a>
</div>
<div class="official">
	The official version of this file is at <a href="http://applet-bots.sourceforge.net/applets/directedKicker.html">applet-bots.sourceforge.net</a>
	<a href="http://sourceforge.net" class="sf-logo"><img border="0" alt="SourceForge.net Logo" src="http://sflogo.sourceforge.net/sflogo.php?group_id=205988&amp;type=1"/></a>
</div>
</body>
</html>
